// Playground - noun: a place where people can play

import Cocoa
import Foundation

// Funktion um eines Liste von Zufallszahlen zu erzeugen
func createRandomNumbers(count:Int, action:(value:[Int]) ->() )
{
    var numbers = [Int]()
    
    // Zufallszahlen von 0 bis 199 generieren
    for var i = 0; i < count; i++
    {
        var number = Int(arc4random_uniform(200))
        numbers.append(number)
    }
    
    // Den Closure aufrufen
    action(value: numbers)
}

// Definition eines Closure der ein Integr-Array
// entgegennimmt und keinen Wert zurückgibt
var output =
{
    (values:[Int]) -> () in
    for value in values
    {
        println("Wert: \(value)")
    }
    
    println("Der erste Wert ist: \(values.first!)")
    println("Der letzte Wert ist: \(values.last!)")
}

// Funktion mit der Anzahl der Zufallszahlen
// und dem Closure als Parameter aufrufen
createRandomNumbers(5, output)

// Aufruf als Inline-Closure
createRandomNumbers(5)
{
        (values:[Int]) -> () in
        for value in values
        {
            println("Wert: \(value)")
        }
        println("Der erste Wert ist: \(values.first!)")
        println("Der letzte Wert ist: \(values.last!)")
}

// -----------------------------------------------------


// Definition eines Closures zu Ausgabe
var showFriends =
{
    (name:String) -> () in
    println("Hallo \(name)!")
}

var friends = ["Mike", "Marika", "Andreas", "Peter", "Sabine"]

// Alle Elemente aus dem Array ansprechen 
// mit der map-Methode
friends.map(showFriends)

// Closure als Inline-Aufruf
friends.map({
    (name:String) -> () in
    println("Hallo \(name)")
})

// Inline-Closure Version 2
friends.map({ println("Hallo \($0)!") })

// Inline-Closure Version 3
friends.map(){ println("Hallo \($0)!") }

// Inline-Closure Version 4
friends.map{ println("Hallo \($0)!") }

